bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/AddAgreementBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.AgreementTextEntity;
import edu.kit.scc.webreg.entity.PolicyEntity;
import edu.kit.scc.webreg.service.AgreementTextService;
import edu.kit.scc.webreg.service.PolicyService;

@Named
@ViewScoped
public class AddAgreementBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private PolicyService policyService;

	@Inject
	private AgreementTextService service;
	
	private PolicyEntity policy;
	
	private AgreementTextEntity entity;
	
	private Long policyId;

	public void preRenderView(ComponentSystemEvent ev) {
		policy = policyService.fetch(policyId);
		entity = service.createNew();
	}
	
	public String save() {
		entity.setPolicy(policy);
		service.save(entity);
		return "show-policy.xhtml?faces-redirect=true&id=" + policy.getId();
	}

	public PolicyEntity getPolicy() {
		return policy;
	}

	public void setPolicy(PolicyEntity policy) {
		this.policy = policy;
	}

	public AgreementTextEntity getEntity() {
		return entity;
	}

	public void setEntity(AgreementTextEntity entity) {
		this.entity = entity;
	}

	public Long getPolicyId() {
		return policyId;
	}

	public void setPolicyId(Long policyId) {
		this.policyId = policyId;
	}
	
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/AddEmailSignatureBean.java
/*
 * *****************************************************************************
 * Copyright (c) 2014 Michael Simon. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the GNU Public
 * License v3.0 which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Contributors: Michael Simon - initial
 * *****************************************************************************
 */
package edu.kit.scc.webreg.bean.admin.service;

import static edu.kit.scc.webreg.service.impl.KeyStoreService.KEYSTORE_CONTEXT_EMAIL;

import java.io.Serializable;

import org.apache.commons.lang.StringUtils;

import edu.kit.scc.webreg.service.impl.KeyStoreService;
import edu.kit.scc.webreg.util.ViewIds;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

@Named
@ViewScoped
public class AddEmailSignatureBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private KeyStoreService keyStoreService;

	private String alias = null;
	private String privateKeyPem = null;
	private String certificateChainPem = null;

	public String save() {
		keyStoreService.storePrivateKeyEntry(KEYSTORE_CONTEXT_EMAIL, alias, privateKeyPem, certificateChainPem);
		alias = null;
		privateKeyPem = null;
		certificateChainPem = null;
		return ViewIds.SHOW_EMAIL_OVERVIEW + "?faces-redirect=true";
	}

	public String cancel() {
		alias = null;
		privateKeyPem = null;
		certificateChainPem = null;
		return ViewIds.SHOW_EMAIL_OVERVIEW + "?faces-redirect=true";
	}

	public Boolean getSaveDisabled() {
		return StringUtils.isEmpty(certificateChainPem) || StringUtils.isEmpty(privateKeyPem);
	}

	public String getPrivateKeyPem() {
		return privateKeyPem;
	}

	public void setPrivateKeyPem(String privateKeyPem) {
		this.privateKeyPem = privateKeyPem;
	}

	public String getCertificateChainPem() {
		return certificateChainPem;
	}

	public void setCertificateChainPem(String certificateChainPem) {
		this.certificateChainPem = certificateChainPem;
	}

	public String getAlias() {
		return alias;
	}

	public void setAlias(String alias) {
		this.alias = alias;
	}

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/AddEmailTemplateBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.EmailTemplateEntity;
import edu.kit.scc.webreg.service.EmailTemplateService;
import edu.kit.scc.webreg.util.ViewIds;

@Named
@ViewScoped
public class AddEmailTemplateBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private EmailTemplateService service;

	private EmailTemplateEntity entity;
	
	public void preRenderView(ComponentSystemEvent ev) {
		entity = service.createNew();
	}
	
	public String save() {
		entity = service.save(entity);
		return ViewIds.SHOW_EMAIL_TEMPLATE + "?faces-redirect=true&id=" + entity.getId();
	}
	
	public EmailTemplateEntity getEntity() {
		return entity;
	}

	public void setEntity(EmailTemplateEntity entity) {
		this.entity = entity;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/AddPolicyBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.PolicyEntity;
import edu.kit.scc.webreg.entity.ServiceEntity;
import edu.kit.scc.webreg.entity.project.ProjectPolicyType;
import edu.kit.scc.webreg.service.PolicyService;
import edu.kit.scc.webreg.service.ServiceService;
import edu.kit.scc.webreg.util.ViewIds;

@Named
@ViewScoped
public class AddPolicyBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private ServiceService serviceService;

	@Inject
	private PolicyService policyService;

	private PolicyEntity entity;
	
	private ServiceEntity service;
	
	private Long serviceId;

	private String policyType;
	
	public void preRenderView(ComponentSystemEvent ev) {	
	}
	
	public String save() {
		if ("project_policy".equals(policyType)) {
			getEntity().setProjectPolicy(service);
		}
		else {
			getEntity().setProjectPolicyType(null);
			getEntity().setService(service);
		}
		policyService.save(getEntity());
		return ViewIds.SHOW_SERVICE + "?faces-redirect=true&id=" + service.getId();
	}
	
	public Long getServiceId() {
		return serviceId;
	}

	public void setServiceId(Long serviceId) {
		this.serviceId = serviceId;
	}

	public PolicyEntity getEntity() {
		if (entity == null) {
			entity = policyService.createNew();
		}
		return entity;
	}

	public void setEntity(PolicyEntity entity) {
		this.entity = entity;
	}

	public ServiceEntity getService() {
		if (service == null) {
			service = serviceService.fetch(serviceId);
		}
		return service;
	}

	public void setService(ServiceEntity service) {
		this.service = service;
	}

	public String getPolicyType() {
		return policyType;
	}

	public void setPolicyType(String policyType) {
		this.policyType = policyType;
	}
	
	public ProjectPolicyType[] getProjectPolicyTypes() {
		return ProjectPolicyType.values();
	}	
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/AddServiceBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.ServiceEntity;
import edu.kit.scc.webreg.service.ServiceService;
import edu.kit.scc.webreg.util.ViewIds;

@Named
@ViewScoped
public class AddServiceBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private ServiceService serviceService;
	
	private ServiceEntity entity;
	
	public void preRenderView(ComponentSystemEvent ev) {
		entity = serviceService.createNew();
	}

	public String save() {
		serviceService.save(entity);
		return ViewIds.LIST_SERVICES;
	}
	
	public ServiceEntity getEntity() {
		return entity;
	}

	public void setEntity(ServiceEntity entity) {
		this.entity = entity;
	}
	
	
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/DeleteEmailSignatureBean.java
/*
 * *****************************************************************************
 * Copyright (c) 2014 Michael Simon. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the GNU Public
 * License v3.0 which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 *
 * Contributors: Michael Simon - initial
 * *****************************************************************************
 */
package edu.kit.scc.webreg.bean.admin.service;

import static edu.kit.scc.webreg.service.impl.KeyStoreService.KEYSTORE_CONTEXT_EMAIL;

import java.io.Serializable;

import edu.kit.scc.webreg.service.impl.KeyStoreService;
import edu.kit.scc.webreg.util.ViewIds;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

@Named
@ViewScoped
public class DeleteEmailSignatureBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private KeyStoreService keyStoreService;

	private String alias;
	
	public String delete() {
		keyStoreService.deletePrivateKeyEntry(KEYSTORE_CONTEXT_EMAIL, alias);
		return ViewIds.SHOW_EMAIL_OVERVIEW + "?faces-redirect=true";
	}

	public String cancel() {
		return ViewIds.SHOW_EMAIL_OVERVIEW + "?faces-redirect=true";
	}

	public String getAlias() {
		return alias;
	}

	public void setAlias(String alias) {
		this.alias = alias;
	}

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/EditServiceEventBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;
import java.util.List;

import jakarta.faces.event.ComponentSystemEvent;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.EventType;
import edu.kit.scc.webreg.entity.JobClassEntity;
import edu.kit.scc.webreg.entity.ServiceEntity;
import edu.kit.scc.webreg.entity.ServiceEventEntity;
import edu.kit.scc.webreg.service.JobClassService;
import edu.kit.scc.webreg.service.ServiceEventService;
import edu.kit.scc.webreg.service.ServiceService;
import edu.kit.scc.webreg.util.ViewIds;

@Named
@ViewScoped
public class EditServiceEventBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private ServiceService service;

	@Inject
	private ServiceEventService eventService;

	@Inject
	private JobClassService jobClassService;
	
	private ServiceEntity entity;
	
	private List<ServiceEventEntity> eventList;
	
	private List<JobClassEntity> jobClassList;
	
	private JobClassEntity selectedJobClass;
	
	private EventType selectedRegisterEventType;
	
	private Long id;
	
	public void preRenderView(ComponentSystemEvent ev) {
		if (entity == null) {
			entity = service.fetch(id);
			eventList = eventService.findAllByService(entity);
			jobClassList = jobClassService.findAll();
		}
	}

	public void addEvent() {
		ServiceEventEntity ev = eventService.createNew();
		ev.setJobClass(selectedJobClass);
		ev.setEventType(selectedRegisterEventType);
		ev.setService(entity);
		eventService.save(ev);
		eventList = eventService.findAllByService(entity);
		selectedJobClass = null;
	}
	
	public void removeEvent(ServiceEventEntity ev) {
		selectedJobClass = ev.getJobClass();
		selectedRegisterEventType = ev.getEventType();
		eventService.delete(ev);
		eventList = eventService.findAllByService(entity);
	}
	
	public String back() {
		return ViewIds.SHOW_SERVICE + "?faces-redirect=true&id=" + entity.getId();
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public ServiceEntity getEntity() {
		return entity;
	}

	public void setEntity(ServiceEntity entity) {
		this.entity = entity;
	}

	public List<ServiceEventEntity> getEventList() {
		return eventList;
	}

	public EventType[] getServiceRegisterEventTypes() {
		return EventType.values();
	}

	public List<JobClassEntity> getJobClassList() {
		return jobClassList;
	}

	public void setJobClassList(List<JobClassEntity> jobClassList) {
		this.jobClassList = jobClassList;
	}

	public JobClassEntity getSelectedJobClass() {
		return selectedJobClass;
	}

	public void setSelectedJobClass(JobClassEntity selectedJobClass) {
		this.selectedJobClass = selectedJobClass;
	}

	public EventType getSelectedRegisterEventType() {
		return selectedRegisterEventType;
	}

	public void setSelectedRegisterEventType(
			EventType selectedRegisterEventType) {
		this.selectedRegisterEventType = selectedRegisterEventType;
	}
}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/ListServiceBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import org.primefaces.model.LazyDataModel;

import edu.kit.scc.webreg.entity.ServiceEntity;
import edu.kit.scc.webreg.model.GenericLazyDataModelImpl;
import edu.kit.scc.webreg.service.ServiceService;

@Named
@ViewScoped
public class ListServiceBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private LazyDataModel<ServiceEntity> list;
    
    @Inject
    private ServiceService service;

    public LazyDataModel<ServiceEntity> getServiceEntityList() {
    	if (list == null) 
    		list = new GenericLazyDataModelImpl<ServiceEntity, ServiceService>(service);
   		return list;
    }

}

bwreg-webapp/src/main/java/edu/kit/scc/webreg/bean/admin/service/ShowEmailTemplateBean.java
/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.bean.admin.service;

import java.io.Serializable;

import jakarta.enterprise.context.RequestScoped;
import jakarta.faces.event.ComponentSystemEvent;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import edu.kit.scc.webreg.entity.EmailTemplateEntity;
import edu.kit.scc.webreg.service.EmailTemplateService;

@Named("showEmailTemplateBean")
@RequestScoped
public class ShowEmailTemplateBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private EmailTemplateService service;

	private EmailTemplateEntity entity;
	
	private Long id;

	public void preRenderView(ComponentSystemEvent ev) {
		entity = service.fetch(id);
	}
	
	public EmailTemplateEntity getEntity() {
		return entity;
	}

	public void setEntity(EmailTemplateEntity entity) {
		this.entity = entity;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}
}

bwreg-webapp/src/main/webapp/admin/service/add-policy.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui">
<head>
<title></title>
</head>
<body>
<f:view>
	<f:metadata>
		<f:viewParam name="serviceId" value="#{addPolicyBean.serviceId}"/>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{addPolicyBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default-admin.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	<h:form id="form">
		<h2><h:outputText value="#{addPolicyBean.service.name}: #{messages.add_policy}"/></h2>
	
		<div id="panelInline">
			<p:panel header="#{messages.policy}">
				<p:panelGrid id="baseData" columns="2" layout="flex" columnClasses="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
		
			        <p:outputLabel value="#{messages.service} #{messages.id}:"/>
			        <h:outputText value="#{addPolicyBean.service.id}"/>
			
					<bw:inputText id="nameField" label="#{messages.name}"
						value="#{addPolicyBean.entity.name}" required="true" />
			
					<p:outputLabel value="#{messages.policy_type}" />
	                <p:selectOneMenu id="option" value="#{addPolicyBean.policyType}">
	                	<p:ajax update="@form"/>
	                    <f:selectItem itemLabel="Policy for Service" itemValue="service_policy"/>
	                    <f:selectItem itemLabel="Policy for Projects" itemValue="project_policy"/>
	                </p:selectOneMenu>

					<p:outputLabel id="pptLabel" value="#{messages.policy_type}" rendered="#{addPolicyBean.policyType == 'project_policy'}"/>
	                <p:selectOneMenu id="ppt" value="#{addPolicyBean.entity.projectPolicyType}" rendered="#{addPolicyBean.policyType == 'project_policy'}">
	                    <f:selectItems value="#{addPolicyBean.projectPolicyTypes}" 
								var="et" itemLabel="#{et}" itemValue="#{et}"/>
	                </p:selectOneMenu>

				</p:panelGrid>
				<p:commandButton id="save" action="#{addPolicyBean.save}" value="#{messages.save}"/>
			</p:panel>
		</div>

	</h:form>

	</ui:define>
</ui:composition>
</f:view>		
</body>
</html>

bwreg-webapp/src/main/webapp/admin/service/edit-policy.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui">
<head>
<title></title>
</head>
<body>
<f:view>
	<f:metadata>
		<f:viewParam name="id" value="#{editPolicyBean.id}"/>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{editPolicyBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default-admin.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	<h:form id="form">
		<h2><h:outputText value="#{messages.policy}: #{editPolicyBean.entity.name}"/></h2>
	
		<div id="panelInline">
			<p:panel header="#{messages.policy}">
				<p:panelGrid id="baseData" columns="2" layout="flex" columnClasses="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
		
			        <p:outputLabel value="#{messages.id}:"/>
			        <h:outputText value="#{editPolicyBean.entity.id}"/>
			
					<bw:inputText id="nameField" label="#{messages.name}"
						value="#{editPolicyBean.entity.name}" required="true" />

					<h:outputText value="#{messages.hidden}" />
					<p:selectBooleanButton id="hiddenField" 
							onLabel="#{messages.yes}" offLabel="#{messages.no}" 
							value="#{editPolicyBean.entity.hidden}"/>

					<h:outputText value="#{messages.show_only}" />
					<p:selectBooleanButton id="onlyShowField" 
							onLabel="#{messages.yes}" offLabel="#{messages.no}" 
							value="#{editPolicyBean.entity.showOnly}"/>
			
			        <p:outputLabel for="selectAgreement" value="#{messages.actual_agreement}:"/>
			        <p:selectOneMenu id="selectAgreement" value="#{editPolicyBean.selectedAgreement}"
			        	converter="#{agreementTextConverter}">
		            	<f:selectItems value="#{editPolicyBean.entity.agreementTexts}" 
		            		var="at" itemLabel="#{at.name} (id #{at.id})" itemValue="#{at}"/>
		            </p:selectOneMenu>
		            
					<p:outputLabel id="pptLabel" value="#{messages.policy_type}" rendered="#{editPolicyBean.entity.projectPolicy != null}"/>
	                <p:selectOneMenu id="ppt" value="#{editPolicyBean.entity.projectPolicyType}" rendered="#{editPolicyBean.entity.projectPolicy != null}">
	                    <f:selectItems value="#{editPolicyBean.projectPolicyTypes}" 
								var="et" itemLabel="#{et}" itemValue="#{et}"/>
	                </p:selectOneMenu>
		            
				</p:panelGrid>
				<p:commandButton id="save" action="#{editPolicyBean.save}" value="#{messages.save}"/>
			</p:panel>
		</div>
	</h:form>

	</ui:define>
</ui:composition>
</f:view>		
</body>
</html>

bwreg-webapp/src/main/webapp/admin/service/edit-service-event.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui">
<head>
<title></title>
</head>
<body>
<f:view>
	<f:metadata>
		<f:viewParam name="id" value="#{editServiceEventBean.id}"/>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{editServiceEventBean.preRenderView}" />
	</f:metadata>

<ui:composition template="/template/default-admin.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="content">
	<h:form id="form">
		<h2><h:outputText value="#{messages.service_events}: #{editServiceEventBean.entity.name}"/></h2>
	
		<div class="panel">
			<p:panel header="#{messages.policy}">
 				<p:dataTable id="eventTable" var="ev" value="#{editServiceEventBean.eventList}">
 					<p:column>
						<f:facet name="header">
							<h:outputText value="#{messages.job_class}" />
						</f:facet>
				        <p:outputLabel value="#{ev.jobClass.name}"/>
 					</p:column>
 					<p:column>
						<f:facet name="header">
							<h:outputText value="#{messages.event_type}" />
						</f:facet>
				        <p:outputLabel value="#{ev.eventType}"/>
 					</p:column>
 					<p:column>
						<f:facet name="header">
							<h:outputText value="#{messages.action}" />
						</f:facet>
						<h:commandLink value="#{messages.remove}" action="#{editServiceEventBean.removeEvent(ev)}">
							<f:ajax render=":form:newPropTable :form:eventTable" />
						</h:commandLink>
 					</p:column>
				</p:dataTable>

				<h:panelGrid id="newPropTable" columns="3" columnClasses="labelColumn, elementColumn">

			        <p:selectOneMenu value="#{editServiceEventBean.selectedJobClass}"
			        	converter="#{jobClassConverter}">
			        	<f:selectItem itemLabel="Keine Job Klasse" itemValue="#{null}"/>
		            	<f:selectItems value="#{editServiceEventBean.jobClassList}" 
		            		var="jc" itemLabel="#{jc.name} (id #{jc.id})" itemValue="#{jc}"/>
		            </p:selectOneMenu>

			        <p:selectOneMenu value="#{editServiceEventBean.selectedRegisterEventType}">
		            	<f:selectItems value="#{editServiceEventBean.serviceRegisterEventTypes}" 
		            		var="et" itemLabel="#{et}" itemValue="#{et}"/>
		            </p:selectOneMenu>
		            
					<h:commandLink value="#{messages.add}" action="#{editServiceEventBean.addEvent()}">
						<f:ajax execute=":form:newPropTable" render=":form:newPropTable :form:eventTable" />
					</h:commandLink>
				</h:panelGrid>
				
			</p:panel>
		</div>
	</h:form>

	</ui:define>
</ui:composition>
</f:view>		
</body>
</html>